<template>
    <div ref="dropdown">
        <div v-if="altMenuComponent"
            :id="id"
            ref="dropdown"
            class="alt-dropdown"
            :class="{'alt-dropdown-open': dropdownActive}"
            @click="onClick">
            <slot></slot>
        </div>
        <div v-if="dropdownOptions && !altMenuComponent"
            :id="id"
            class="dropdown"
            :class="{'dropdown-open': dropdownActive}"
            @click="onClick">
            <div v-if="updatePlaceholderOnSelection && selectedOption && selectedOption.display"
                class="dropdown-option selected-option">
                {{ selectedOption.display }}</div>
            <div v-else-if="placeholder" class="dropdown-option selected-option">
                {{ placeholder }}</div>
            <div v-else class="dropdown-option selected-option">
                {{ dropdownOptions[0].display }}</div>
        </div>
        <div v-if="dropdownActive" class="dropdown-options" :style="{'max-height': maxHeight}">
            <div v-if="multiselect" class="dropdown-actions">
                <a v-if="selectAll" @click="selectAllOptions(true)">Select All</a>
                <a v-else @click="selectAllOptions(false)">Unselect All</a>
            </div>
            <div class="dropdown-option" v-for="option in dropdownOptions"
                :key="option.value"
                :id="'option-' + option.display"
                :value="option.value"
                :class="option.classes"
                @click="selectOption(option, $event)">
                <div v-if="multiselect" class="multiselect-option">
                    <input :id="'checkbox-' + option.display"
                        type="checkbox"
                        v-model="option.selected" />
                    <label :for="'checkbox-' + option.display">
                        {{ option.display }}
                    </label>
                </div>
                <div v-else>{{ option.display }}</div>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    name: 'CumulusDropdown',

    props: {
        altMenuComponent: {
            default: false,
            type: Boolean,
        },
        disabled: {
            default: false,
            type: Boolean,
        },
        id: String,
        maxHeight: {
            default: '100%',
            type: String,
        },
        multiselect: {
            default: false,
            type: Boolean,
        },
        options: Array,
        placeholder: String,
        updatePlaceholderOnSelection: {
            default: true,
            type: Boolean,
        },
    },

    data() {
        return {
            dropdownActive: false,
            selectAll: true,
            selectedOption: undefined,
        };
    },

    computed: {
        dropdownOptions() {
            return this.options.map(option => {
                if (option.selected) {
                    this.selectedOption = option;
                }
                return option;
            });
        },
    },

    methods: {
        onClick($event) {
            if (this.disabled) { return; }
            this.dropdownActive = !this.dropdownActive;
            const eventName = this.dropdownActive ? 'dropdownOpened' : 'dropdownClosed';
            this.$emit(eventName, $event);
        },
        selectAllOptions(select) {
            this.options.forEach(opt => { opt.selected = select; });
            this.selectAll = !this.selectAll;
            const event = select ? 'selectedAll' : 'unselectedAll';
            this.$emit(event);
        },
        selectOption(option, event) {
            if (event.target.tagName === 'LABEL') {
                return; // ignore clicks on the label, a separate event will fire for the input
            }
            if (this.multiselect) {
                this.$emit('dropdownMultiselectChanged', { ...option, selected: !option.selected });
            } else {
                this.options.forEach(opt => { opt.selected = false; });
                option.selected = true;
                this.dropdownActive = false;
                this.$emit('dropdownValueChanged', option.value, event);
            }
            this.selectedOption = option;
        },
    },

    mounted() {
        document.addEventListener('click', event => {
            try {
                const { dropdown } = this.$refs;
                const { target } = event;
                if (!dropdown.contains(target)) {
                    this.dropdownActive = false;
                }
            } catch (err) {
                // ignore
            }
        });
    },
};
</script>
<style lang="scss" scoped>
.dropdown-options {
    overflow-y: auto;
}
.multiselect-option {
    display: flex;

    label {
        width: 100%;
    }
}
</style>
